/*
 * @package netNotes
 * @author Sebastian Tschan
 * @copyright (c) Sebastian Tschan
 * @license GNU General Public License
 * @link https://blueimp.net/mozilla/
 */

const EXPORTED_SYMBOLS = ['LocationManager'];

const Ci = Components.interfaces;
const Cr = Components.results;
const Cu = Components.utils;

Cu.import('resource://netNotes/utils.js');

var LocationListener = {

	listeners: [],
	
	QueryInterface: function(IID) {
		if(	IID.equals(Ci.nsIWebProgressListener) ||
			IID.equals(Ci.nsISupportsWeakReference) ||
			IID.equals(Ci.nsISupports)
			) return this;
		throw Cr.NS_NOINTERFACE;
	},

	onLocationChange: function(progress, request, uri) {
		this.listeners.forEach(
			function(listener) {
				listener(uri);
			}
		);
	},

	onStateChange: function() {},
	onProgressChange: function() {},
	onStatusChange: function() {},
	onSecurityChange: function() {},
	onLinkIconAvailable: function() {}

}

const Ll = LocationListener.listeners;

let LocationManager = {
	
	addListener: function(listener) {
		if(!Ll.length) {
			Ll.push(listener);
			Utils.getBrowser().addProgressListener(
				LocationListener,
				Ci.nsIWebProgress.NOTIFY_STATE_DOCUMENT
        	);
		} else {
			var index = Ll.indexOf(listener);
			if(index == -1) {
				Ll.push(listener);
			}
		}
	},
	
	removeListener: function(listener) {
		var index = Ll.indexOf(listener);
		if(index != -1) {
			Ll.splice(index,1);
		}
		if(!Ll.length) {
			Utils.getBrowser().removeProgressListener(LocationListener);
		}
	}

}